/*=============================================================================
  Copyright (c) YOUR_COPYRIGHT_MESSAGE_HERE

  File: HandleVisibility_entry_action.h

  Author: YOU
  Date: DATE

  Description: { fill in with your module's ACCESS_ACTION handler, some common AN's are provided }

=============================================================================*/
#include "ActionExamples.h"

char * HandleVisibility_key;

FX_ENTRYFUNC(HandleVisibility_entry_action)
// FXint f(FX_AccessInfo *ai, FXentity ID, FXint64 entry)
{
	FXaction act = (FXaction)ID;		// object that triggered this notification
	FXhandle hand = FX_NULLID;			// handle this action is attached to
	FXhandle child = FX_NULLID;
	FXhandle parent = FX_NULLID;
	FXint flags;
	HandleVisibility_state *state = NULL;

	hand = fxActionHandle( act, FX_NOFLAG );

	switch( entry )
	{
	case ACT_CREATE:
		{
			if( !(state = fxDataCreate(act, &HandleVisibility_key, 0, sizeof(HandleVisibility_state))) )
			{
				fxMessageSend( act, "ActionExamples.mp", FX_MESSAGE_ERROR, "HandleVisibility - Allocation Failure", NULL );
				return ENTRY_BREAK;
			}

			state->show = HV_HIDE;
			state->affects = HV_SELF;

		}
		break;

	case ACT_SAVE:
		{
			FX_Format *f = fxFormatNew( ai, "HandleVisibility", FX_NOFLAG );
			if(!f) return ENTRY_BREAK;
			
			// get state data from action
			if( !(state = fxDataGet( act, &HandleVisibility_key, 0)) )
			{
				fxMessageSend( act, "ActionExamples.mp", FX_MESSAGE_ERROR, "HandleVisibility - Data Retrieval Failure", NULL );
				return ENTRY_BREAK;
			}

			fxArgSaveInt( f, "show", state->show );
			fxArgSaveInt( f, "affects", state->affects );

		}
		break;

	case ACT_LOAD:
		{
			FX_Format *f = fxFormatGet( ai, "HandleVisibility" );
			if(!f) return ENTRY_BREAK;
			
			// get state data from action
			if( !(state = fxDataGet( act, &HandleVisibility_key, 0)) )
			{
				fxMessageSend( act, "ActionExamples.mp", FX_MESSAGE_ERROR, "HandleVisibility - Data Retrieval Failure", NULL );
				return ENTRY_BREAK;
			}

			fxArgLoadInt( f, "show", &(state->show) );
			fxArgLoadInt( f, "affects", &(state->affects) );

		}
		break;

	case ACT_PROCESS:
		{
			if( !(state = fxDataGet( act, &HandleVisibility_key, 0)) )
			{
				fxMessageSend( act, "ActionExamples.mp", FX_MESSAGE_ERROR, "HandleVisibility - Data Retrieval Failure", NULL );
				return ENTRY_BREAK;
			}

			// If we're affecting a handle's siblings we'll need to get the first child of its parent
			if( state->affects == HV_SIBLINGS )
			{
				parent = fxHandleParent( hand, FX_NOFLAG );
				child = fxHandleChild( parent, FX_NOFLAG );
			}
			// If we're affecting a handle's children we'll need to start with the first child
			if( state->affects == HV_CHILDREN )
			{
				child = fxHandleChild( hand, FX_NOFLAG );
			}
			// If we're affecting either the handle's children or siblings we can use the same loop
			if( state->affects == HV_SIBLINGS || state->affects == HV_CHILDREN )
			{
				while( child )
				{
					// get the handles current options
					fxHandleOptions( child, &flags, FX_NOFLAG );

					// if the handle is already hidden, and we're supposed to show or toggle it
					if( flags & FX_ARMDATA_MUTE && (state->show == HV_SHOW || state->show == HV_TOGGLE) )
						fxHandleOptionsClear( child, FX_ARMDATA_MUTE, FX_NOFLAG );
					// if the handle is already visible, and we're supposed to hide or toggle it
					else if( state->show == HV_HIDE || state->show == HV_TOGGLE )
						fxHandleOptionsSet( child, FX_ARMDATA_MUTE, FX_NOFLAG );

					// move on to next sibling
					child = fxHandleNext( child, FX_NOFLAG );

				}
			}

			// If we're only affecting the handle itself
			if( state->affects == HV_SELF )
			{
				fxHandleOptions( hand, &flags, FX_NOFLAG );

				switch( state->show )
				{

				case HV_SHOW:
				case HV_TOGGLE:
					if( flags & FX_ARMDATA_MUTE )
						fxHandleOptionsClear( hand, FX_ARMDATA_MUTE, FX_NOFLAG );
					else
						fxHandleOptionsSet( hand, FX_ARMDATA_MUTE, FX_NOFLAG );
					break;

				case HV_KEY_EXISTS:
				case HV_NO_KEY:
					{
						FXobject ctlr = FX_NULLID;

						ctlr = fxHandleController( hand, FX_NOFLAG );

						if( ctlr )
						{
							

						}

					}
					break;
				}
				
			}

			// once everything is done, we'll need to update the interface for our changes to take affect
			fxInterfaceUpdate(FX_UPDATE_WORLD|FX_UPDATE_LIST, FX_NOFLAG );

		}// ACT_PROCESS
		break;
	}

	return ENTRY_OK;

}
