/*=============================================================================
  Copyright (c) 1999-2003 pmG Worldwide, LLC.

  Author: Lyle Milton
  Date: 03/14/03

  Description: Simple effect that causes a point to lag behind the motion of the 
  object based on their distance from the pivot.
  See the tutorials section of the docs for a detailed description of this file.	

=============================================================================*/
#define _MESSIAH_FULL_API
#include <messiah_main.h>

// Access Function
FX_ACCESSFUNC(LagPointsAccess);

// Effect's state data structure
typedef struct
{
	FXdouble		lag;
	FXtool			weight_obj;
	FXint			scan;

	//work variables - used to increase speed of pointscan
	FXdouble		frame;
	FXvecd			piv, loc;
	FXobject		piv_obj;
	FXint			use_piv;
	FXobject		mot_obj;

}LagPointState;


