/*=============================================================================
  Copyright (c) 1999-2003 pmG Worldwide, LLC.

  Author: Ron Griswold
  Date: 03/14/03

  Description: Simple effect that scales an object's points along their normals.
  See the tutorials section of the docs for a detailed description of this file.	

=============================================================================*/
#define _MAINPLUGIN_FILE
#include "NormScale.h"

_pluginEntry
// FXint messiahEntry(FXchar pname[256], FXvoid *api_func, FXint api, FXint program, const FXchar *rev)
{
	// Get all API components and do initial plugin setup
	_MESSIAH_PLUGIN_ALL("Norm_Scale");

	// Describe the effect in English
	fxModuleDescription("Scale a mesh's points along their normals", FX_NOFLAG);

	// Request AN messages
	fxModuleAccess(ACCESS_OBJECT, O_CREATE|O_DESTROY, FX_NOFLAG);
	fxModuleAccess(ACCESS_SYSTEM, S_MODULE_INIT, FX_NOFLAG);
	fxModuleAccess(ACCESS_PROCESS, P_POST_POINT_DISPLACE, FX_NOFLAG);

	// Register the effect
	fxModuleRegister( FX_MODTYPE_EFFECT, "NormScale", &NormScaleAccess, FX_NOFLAG);

	return FX_PLUGIN_OK;
}

_pluginExit
// FXvoid messiahExit(FXvoid)
{

}
