/*=============================================================================
	Copyright (c) 1999-2004 pmG Worldwide, LLC.

	File:	messiah_object.h
	Author:	Lyle Milton
	Date:	01/01/03

		last modified: 05/25/04 - LM
			- FX_OBJPATH_ABSOLUTE

=============================================================================*/

#ifdef _MESSIAH_API_OBJECT

#ifndef __MESSIAH_OBJ
#define __MESSIAH_OBJ


#ifndef __MESSIAH_HIDE_TYPES

	#define FX_TOOLTYPE_SKELETON	"Skeleton"
	#define FX_TOOLTYPE_CAMERA		"Camera"
	#define FX_TOOLTYPE_LIGHT		"Light"
	#define FX_TOOLTYPE_CURVE		"Curve"
	#define FX_TOOLTYPE_NULL		"Null"
	#define FX_TOOLTYPE_SLIDER		"Slider"
	#define FX_TOOLTYPE_CLUSTER		"Cluster"
	#define FX_TOOLTYPE_FORCE		"Force"
	#define FX_TOOLTYPE_PROCEDURAL	"Procedural"
	#define FX_TOOLTYPE_MEFFECTOR	"MetaEffector"
	#define FX_TOOLTYPE_VALUE		"Value"


	#define FX_MANIPULATOR_SPHERE	"EditSphere"
	#define FX_MANIPULATOR_SLIDER	"EditSlider"

	#define FX_HIERARCHYSCAN(f, dt, ed)	FXintf f(FXobject obj, dt *ed)

	#define FX_OBJIK_2D				0
	#define FX_OBJIK_TELESCOPIC		1

	#define FX_OBJIKDIR_POSITIVE	0
	#define FX_OBJIKDIR_NEGATIVE	1

	#define FX_OBJIKCHAN_ON			(1<<0)
	#define FX_OBJIKCHAN_LIMIT		(1<<1)


	//For use with fxObjectDrawModeSet,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
	// Note: because there may be many more drawing modes added to messiah in
	//			later revs, it may be necessary to rearrange the drawing modes
	//			according to type.  This precludes draw mode IDs.  So, you'll
	//			need to use drawmode names for getting & setting object drawing.
	//
	#define FX_OBJDRAW_NONE					"NONE"
	#define FX_OBJDRAW_BBOX					"BoundingBoxWire"
	#define FX_OBJDRAW_POINTS				"Points"
	#define FX_OBJDRAW_EDGES				"Edges"
	#define FX_OBJDRAW_FACET				"Facet"
	#define FX_OBJDRAW_FACETEDGES			"Facet_&_Edges"
	#define FX_OBJDRAW_SMOOTH				"Smooth"
	#define FX_OBJDRAW_SMOOTHEDGES			"Smooth_&_Edges"
	#define FX_OBJDRAW_SMOOTHWIRE			"SmoothWire"
	#define FX_OBJDRAW_WEIGHT				"Weight"
	#define FX_OBJDRAW_WEIGHTEDGES			"Weight_&_Edges"
	#define FX_OBJDRAW_WEIGHTWIRE			"WeightWire"
	#define FX_OBJDRAW_TEXTURE				"Texture"
	#define FX_OBJDRAW_TEXTUREEDGES			"Texture_&_Edges"
	#define FX_OBJDRAW_TEXTUREWIRE			"TextureWire"
	#define FX_OBJDRAW_TEXTUREFLAT			"TextureFlat"
	#define FX_OBJDRAW_TEXTUREFLATEDGES		"TextureFlat_&_Edges"
	#define FX_OBJDRAW_FLAT					"Flat"
	#define FX_OBJDRAW_TOON					"Toon"
	#define FX_OBJDRAW_ANIME				"Anime"
	#define FX_OBJDRAW_LINE					"Line"
	//`````````````````````````````````````````````````````````````````````````


	//For use with fxObjectDelete,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
	#define FX_OBJDELETE_CHILDREN	(1<<0)


	//For use with fxObjectLock* & fxObjectUnlock,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
	//	Note:	if no flags are supplied, it is assumed that you want the
	//			functions to perform operations for soft AND hard locking. 
	//	EX:
	//		to hard & softlock....	fxObjectLockSet(0)
	//		to softlock only......	fxObjectLockSet(FX_OBJLOCK_SOFT)
	//
	#define FX_OBJLOCK_SOFT			(1<<0)
	#define FX_OBJLOCK_HARD			(1<<1)
	//`````````````````````````````````````````````````````````````````````````

	//For use with fxObjectGetPath,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
	#define FX_OBJPATH_ABSOLUTE		(1<<0)


#endif //__MESSIAH_HIDE_TYPES


FX_API(FXint, fxObjectSetParent)(FXobject, FXobject parentID, FXint flags);

FX_API(FXint, fxObjectSetSibling)(FXobject, FXobject sibID, FXint flags);

FX_API(FXint, fxObjectIsLoading)(FXobject, FXint flags);

FX_API(FXint, fxObjectCheckID)(FXobject);

FX_API(FXint, fxObjectDeleteBegin)(FXmodule, FXint flags);

FX_API(FXint, fxObjectDelete)(FXobject, FXint flags);

FX_API(FXint, fxObjectDeleteEnd)(FXmodule, FXint flags);


FX_API(FXint, fxObjectHierarchyScan)(FXobject, FXint (*scan_func)(FXobject, FXvoid*), FXvoid *data, FXint flags);

FX_API(FXobject, fxObjectFind)(FXobject, FXchar *prefix, FXchar *name, FXint flags);

FX_API(FXint, fxObjectLayerNumber)(FXobject, FXint *layerID, FXint flags);

FX_API(FXint, fxObjectGetPath)(FXobject, FXchar *buffer, FXint buffer_size, FXint flags);

FX_API(FXint, fxObjectGetName)(FXobject, FXchar *buffer, FXint buffer_size, FXint flags);

FX_API(FXint, fxObjectRename)(FXobject, FXchar *name, FXint flags);

FX_API(FXint, fxObjectGetType)(FXobject, FXchar *buffer, FXint buffer_size, FXint *sub_type, FXint flags);

FX_API(FXint, fxObjectIsType)(FXobject, FXchar *type, FXint flags);

FX_API(FXint, fxObjectIsSubtype)(FXobject, FXint sub_type, FXint flags);

FX_API(FXvoid*, fxObjectGetTypeData)(FXobject, FXint flags);

FX_API(FXint, fxObjectSetTypeData)(FXobject, FXvoid *data, FXint flags);

FX_API(FXint, fxObjectIsGeometric)(FXobject, FXint flags);

FX_API(FXobject, fxObjectFirst)(FXint flags);

FX_API(FXobject, fxObjectNext)(FXobject, FXint flags);

FX_API(FXobject, fxObjectPrev)(FXobject, FXint flags);

FX_API(FXobject, fxObjectChild)(FXobject, FXint flags);

FX_API(FXobject, fxObjectParent)(FXobject, FXint flags);

FX_API(FXtool, fxToolCreate)(FXchar *tool_type, FXchar *tool_name, FXint sub_type, FXint flags);

FX_API(FXtool, fxSubtoolFirst)(FXtool masterID, FXint flags);

FX_API(FXtool, fxSubtoolNext)(FXtool masterID, FXobject objID, FXint flags);

FX_API(FXtool, fxSubtoolPrev)(FXtool masterID, FXobject objID, FXint flags);


FX_API(FXobject, fxObjectCurrent)(FXint flags);

FX_API(FXobject, fxObjectSetCurrent)(FXobject, FXint flags);

FX_API(FXint, fxObjectIsCurrent)(FXobject, FXint flags);

FX_API(FXint, fxObjectSelect)(FXobject, FXint flags);

FX_API(FXint, fxObjectDeselect)(FXobject, FXint flags);

FX_API(FXint, fxObjectDeselectAll)(FXint flags);

FX_API(FXobject, fxObjectFirstSelected)(FXint flags);

FX_API(FXobject, fxObjectNextSelected)(FXobject, FXint flags);

FX_API(FXobject, fxObjectPrevSelected)(FXobject, FXint flags);

FX_API(FXobject, fxObjectLastSelected)(FXint flags);

FX_API(FXint, fxObjectNumSelected)(FXint flags);


FX_API(FXint, fxObjectIKGoal)(FXobject, FXint flags);

FX_API(FXint, fxObjectIKGoalSet)(FXobject objID, FXobject goalID, FXint flags);

FX_API(FXint, fxObjectIK)(FXobject, FXint flags);

FX_API(FXint, fxObjectIKSet)(FXobject, FXint on, FXint flags);

FX_API(FXint, fxObjectIKAnchor)(FXobject, FXint flags);

FX_API(FXint, fxObjectIKAnchorSet)(FXobject, FXint anchor, FXint flags);

FX_API(FXint, fxObjectIKType)(FXobject, FXint flags);

FX_API(FXint, fxObjectIKTypeSet)(FXobject, FXint type, FXint flags);

FX_API(FXint, fxObjectIKDirection)(FXobject, FXint flags);

FX_API(FXint, fxObjectIKDirectionSet)(FXobject, FXint direction, FXint flags);

FX_API(FXfloat, fxObjectIKStrength)(FXobject, FXint flags);

FX_API(FXint, fxObjectIKStrengthSet)(FXobject, FXfloat strength, FXint flags);

FX_API(FXint, fxObjectIKChannel)(FXobject, FXint channel, FXfloat *stiffness, FXfloat *lim_min, FXfloat *lim_max, FXint *flags);

FX_API(FXint, fxObjectIKChannelSet)(FXobject, FXint channel, FXfloat *stiffness, FXfloat *lim_min, FXfloat *lim_max, FXint *flags);

FX_API(FXint, fxObjectDrawMode)(FXobject, FXchar *buffer, FXint buffer_size, FXint flags);

FX_API(FXint, fxObjectDrawModeSet)(FXobject, FXchar *draw_mode, FXint flags);

FX_API(FXint, fxObjectLockGet)(FXobject, FXint flags);

FX_API(FXint, fxObjectLockSet)(FXobject, FXint flags);

FX_API(FXint, fxObjectUnlock)(FXobject, FXint flags);

FX_API(FXint, fxObjectGetActiveCamera)(void);

FX_API(FXobject, fxObjectLoad)(FXchar *filename, FXint flags);

FX_API(FXobject, fxObjectCreateInstance)(FXobject master, FXint flags);


#define _MESSIAH_PTR_OBJECT	messiah_apicomponent = FX_APIFUNCS_OBJECT;\
							FX_PTR(fxObjectSetParent);\
							FX_PTR(fxObjectSetSibling);\
							FX_PTR(fxObjectIsLoading);\
							FX_PTR(fxObjectCheckID);\
							FX_PTR(fxObjectDeleteBegin);\
							FX_PTR(fxObjectDelete);\
							FX_PTR(fxObjectDeleteEnd);\
							FX_PTR(fxObjectHierarchyScan);\
							FX_PTR(fxObjectFind);\
							FX_PTR(fxObjectLayerNumber);\
							FX_PTR(fxObjectGetPath);\
							FX_PTR(fxObjectGetName);\
							FX_PTR(fxObjectRename);\
							FX_PTR(fxObjectGetType);\
							FX_PTR(fxObjectIsType);\
							FX_PTR(fxObjectIsSubtype);\
							FX_PTR(fxObjectGetTypeData);\
							FX_PTR(fxObjectSetTypeData);\
							FX_PTR(fxObjectIsGeometric);\
							FX_PTR(fxObjectFirst);\
							FX_PTR(fxObjectNext);\
							FX_PTR(fxObjectPrev);\
							FX_PTR(fxObjectChild);\
							FX_PTR(fxObjectParent);\
							FX_PTR(fxToolCreate);\
							FX_PTR(fxSubtoolFirst);\
							FX_PTR(fxSubtoolNext);\
							FX_PTR(fxSubtoolPrev);\
							FX_PTR(fxObjectCurrent);\
							FX_PTR(fxObjectSetCurrent);\
							FX_PTR(fxObjectIsCurrent);\
							FX_PTR(fxObjectSelect);\
							FX_PTR(fxObjectDeselect);\
							FX_PTR(fxObjectDeselectAll);\
							FX_PTR(fxObjectFirstSelected);\
							FX_PTR(fxObjectNextSelected);\
							FX_PTR(fxObjectPrevSelected);\
							FX_PTR(fxObjectLastSelected);\
							FX_PTR(fxObjectNumSelected);\
							FX_PTR(fxObjectIKGoal);\
							FX_PTR(fxObjectIKGoalSet);\
							FX_PTR(fxObjectIK);\
							FX_PTR(fxObjectIKSet);\
							FX_PTR(fxObjectIKAnchor);\
							FX_PTR(fxObjectIKAnchorSet);\
							FX_PTR(fxObjectIKType);\
							FX_PTR(fxObjectIKTypeSet);\
							FX_PTR(fxObjectIKDirection);\
							FX_PTR(fxObjectIKDirectionSet);\
							FX_PTR(fxObjectIKStrength);\
							FX_PTR(fxObjectIKStrengthSet);\
							FX_PTR(fxObjectIKChannel);\
							FX_PTR(fxObjectIKChannelSet);\
							FX_PTR(fxObjectDrawMode);\
							FX_PTR(fxObjectDrawModeSet);\
							FX_PTR(fxObjectLockGet);\
							FX_PTR(fxObjectLockSet);\
							FX_PTR(fxObjectUnlock);\
							FX_PTR(fxObjectGetActiveCamera);\
							FX_PTR(fxObjectLoad);\
							FX_PTR(fxObjectCreateInstance)




#endif //__MESSIAH_OBJ

#endif //_MESSIAH_API_OBJECT
